<?php
/* ===========================================================================================
	GALLERYX V1.0  21.10.08
	GALLERYX V1.1  26.11.08
	The original script gallery.php programmed by (c) Oliver Georgi 
	06.10.08 {GALLERYX} patched by K.Heermann (flip-flop) http://planmatrix.de
	                    and  RCS / robin c. sherwood
	06.10.08 {GALLERYX: galleryRoot_ID[int],  subgallery_ID[int], subsubgallery_ID[int]}
	16.10.08 Enhanced for copyright output
	17.10.08 Ehanced for half automatic thumb width/height reduce if image count > X 
	         $thumb_count_to_min -> default = 30
	17.10.08 Enhanced for direct output of a Sub Sub gallery by given ID
	         An subgallery_ID[int] must be set do use this enhancement
	18.10.08 Enhanced caption on/off in list sub gallery 
	18.10.08 Standardise parameter name
	18.10.08 Simple tagging prepared
	25.11.08 Switch for list title & date  - detail title & date  [on|off]
	
	- Gallery (This ID must be declared in $gallery_rootid -> ($my_gallery_rootid))
	--- GALLERY01 ( Switch [gallery root directory])
	----- Gallery01_Sub (this ID must be declared (Switch [gallery subdirectory]) -> ($my_gallery_subid)) // sub or better list
	------- Gallery01_Sub01 (gallery images (folder set [gallery subdirectory]) // sub sub
	------- Gallery01_Sub02 (gallery images (folder set [gallery subdirectory]) // sub sub
	------- Gallery01_Sub03 (gallery images (folder set [gallery subdirectory]) // sub sub
	
	SHORT DEFINATION:
	$my_gallery_rootid => The ID of the folder before [set gallery root directory], 
	                     default = 0 = root
	$my_gallery_subid   => The ID of the first folder [set gallery subdirectory]
	                      if set to 0 (default) the hierarchical master gallery 
	                      and breadcrumb output is active
	                      if > 0 : no master gallery and breadcrumb output like 
                        http://www.foxconncebit.com/index.php?foxconn-cebit-galerie
	$my_subsubgalleryid => The ID of the first folder [set gallery subdirectory]
	                      if set to 0 (default) the hierarchical master gallery 


	 Find the IDs in file cender: 
	 Move the mouse over the [EDIT] button, then have a look 
	 into the browser status bar down stares. (Last number in string).
	
	$my_go_back_text        => Text for the go back link
	
	Used files:
	PHP:    /template/inc_script/frontend_render/galleryx.php  (this file)
	PHP:    /include/inc_lib/imagegalleryx.inc.php             (some basic functions)
	CSS:    /template/inc_css/specific/galleryx.css            (css for the output)
	Templ.: /template/inc_cntpart/filelist/galleryx.html       (Download template)
	
	forum: http://forum.phpwcms.org/viewtopic.php?p=110248#p110248
 ============================================================================================= */
 
// ------------------------------------------------------------------
// obligate check for phpwcms constants
if (!defined('PHPWCMS_ROOT')) {
   die("You Cannot Access This Script Directly, Have a Nice Day."); }
// ------------------------------------------------------------------

	if( strpos($content['all'], '{GALLERYX:') !== FALSE ) {

// load phpwcmsImageGallery class
include_once(PHPWCMS_ROOT.'/include/inc_lib/imagegalleryx.inc.php');


function my_parameter($parameter='') {

$gallery = & new phpwcmsImageGalleryX (); // kh: binding the php class
//$gallery->setQuerySeparator('?');



// +kh: Tag 
// Basic tag: {GALLERYX: galleryRoot_ID[int],  subgallery_ID[int], subsubgallery_ID[int]}
// ===========================================================================================
//	Input parameter (handing over)
// ===========================================================================================
	$parameter              = explode(',', trimhtml($parameter));
	$my_gallery_rootid      = empty($parameter[0]) ? 0  : intval($parameter[0]);
	$my_gallery_subid       = empty($parameter[1]) ? 0  : intval($parameter[1]);
	$my_gallery_sub_subid   = empty($parameter[2]) ? 0  : intval($parameter[2]);

//	Some examples how a new parameter in your tag could look like.	
//	$my_detail_title_date          = empty($parameter[3]) ? 3  : intval($parameter[3]);
//	$my_detail_zoom	               = empty($parameter[4]) ? 0  : intval($parameter[4]);
//	$my_detail_lightbox            = empty($parameter[5]) ? 0  : intval($parameter[5]);
//	$my_detail_thumb_count_to_min  = empty($parameter[6]) ? 0  : intval($parameter[6]);
//	$my_detail_thumb_width_height  = empty($parameter[7]) ? '80x80'  :  trim($parameter[7]);
//	$my_gallery_css                = empty($parameter[8]) ? 'galleryx'  : trim($parameter[8]);
// ===========================================================================================
// ===========================================================================================
//	Have a look for making your own tag e.g.: {GALLERYX: 25, 31, 32, 1, 15, 60x60, mygallery}
//	{GALLERYX:      25,     31,        32,    1,        1,                 15,              60x60,   mygallery}
//	{GALLERYX: root_ID, sub_ID, subsub_ID, zoom, lightbox, thumb_count_to_min, thumb_width_height, gallery_css}

//	Second we must create a new tag: For this individual configuration you can see the 
//	parameter set above (the commented one - uncomment them and it ought to run.) 
//
//	We have only two types of variables, [int] and [string]
//	For [int] please use the intval function (http://us.php.net/manual/en/function.intval.php)
//	For [string] please use the "trim function" (http://de3.php.net/trim)
//
//	Figure out the "short if syntax" (http://www.scottklarr.com/topic/76/tip-of-the-day-php-short-hand-if-statement/)
//
//      [   $variable       = (statement)           ? "return if true"  : "return if false";]
//  e.g.:   $my_gallery_css = empty($parameter[8])  ? 'galleryx'        : trim($parameter[7]);
//  And take care to the running index e.g.   [8]                                        [7]

//	Third we must comment out the corresponding variables in "SHORT DEFINATION" like: 
//	// $my_detail_title_date
//	// $my_detail_zoom 
//	// $my_detail_lightbox 
//	// $my_detail_thumb_count_to_min
//	// $my_detail_thumb_width_height
//	// $my_gallery_css
// ===========================================================================================


// ===============================================================
// SHORT DEFINATION ==============================================
// ===============================================================

// -----------------------------------------------------
// list sub gallery defination 
// -----------------------------------------------------
// string defines the sorting mode of the Gallery and list Sub Galleries image folder:
// NAME-ASC, NAME-DESC, CREATE-ASC, CREATE-DESC
// get images sorted by name or create date
$my_gallery_sort									= 'NAME-ASC'; 

$my_date_format										= '{DATE:d.m.y lang=DE}';

// [0|1|2|3] [off | title=on | date=on | title and date = on]   in sub gallery (list)
$my_list_title_date								= 3; 

$my_list_description_date 				= 1; 		// [0|1] date on/off in description text

// define if an list sub gallery thumbnail should be shown
// 0 = show none, 1 show first, 2 show first and second ...
$my_list_thumbnail 								= 1; 		// [0, 1, 2, 3 ....] output 
$my_list_thumbnail_caption 				= 1; 		// [0|1] caption on/off
$my_list_thumbnail_crop						= 1; 		// [0|1] cropping with $my_list_thumbnail_width_height
$my_list_thumbnail_width_height 	= '50x50';	// width x height


// define the over all copyright text instead of file center copyright. 
// If blank '', the file center copyright is in use.
$my_copyright_text = '[&copy; 2008 name]';

// define what kind of file storage folders should be taken
// true = only folders marked as gallery root or sub directory
	$gallery->gallery_only = true; 

// gallery name can be prefixed by date YYYY-MM-DD,
// use sort by NAME-ASC or NAME-DESC,
// this date will be used as gallery date and
// is stripped from name if $use_name_date = true
	$gallery->use_name_date	= true;


// -----------------------------------------------------
// sub sub gallery definition 
// -----------------------------------------------------
// string defines the sorting mode
// ASC / DESC = get images sorted by date 
// NAME-ASC / NAME_DESC = get images sorted by name  (+kh) 
// RAND = get images by random)
$my_gallery_image_sort			= 'NAME-ASC'; 	// sorting gallery images
$my_gallery_image_limit			= 2; 						// integer the limit of how many images should be retrieved

// [0|1|2|3] [off | title=on | date=on | title and date = on]   in sub sub gallery
$my_detail_title_date					= 3; 
$my_detail_thumb_caption 			= 1; 					// [0|1] caption  on/off in sub sub gallery
$my_detail_descr_info 				= 1; 					// [0|1] Show description from list in detail on/off

// sub sub gallery thumbs
$my_detail_thumb_crop					= 0;					// cropping the image [0|1]
$my_detail_thumb_width_height	= '120x100';	// thumb width x height

// ------ zoom
$my_detail_zoom 							= 1; 					// zoom the image: switch [0|1]
$my_detail_lightbox 					= 1; 					// lightbox: switch [0|1]
$my_detail_zoom_crop 					= 0; 					// cropping the zoom image [0|1] using $my_detail_zoom_width_height
$my_detail_zoom_width_height	= '800x600';	// width x height of the zoomed image

// If more then "thumb_count_to_min" images in selected sub sub gallery placed, 
// they will be reduced to "thumb_width_height_min" 
$my_detail_thumb_count_to_min 			= 30; 		// [integer]
$my_detail_thumb_width_height_min 	= '100x100';// minimal thumb width x height

// ------ download
// combination of download = 1, download_direct = 0 and $phpwcms['inline_download'] = 0; (conf.inc.php) 
// would open a new dialog window with listed real filename
$my_download 							= 0; 	// [0|1]  download on/off  
$my_download_direct				= 0; 	// [0|1]  

$my_go_back_text					= 'Go Back';	// go back link text
// $my_go_back_text				= '[en]Go Back[/en][de]zur&uuml;ck[/de]';	// e.g. for active lang. switch

// download template in /template/inc_cntpart/filelist/*.html
$my_item_download_template		= 'galleryx';  // only the name of the html file without the extend!!!
// css file in /template/inc_css/specific/*.css
$my_gallery_css								= 'galleryx';  // only the name of the css file without the extend!!!

// ===============================================================
// END SHORT DEFINITION ==========================================
// ===============================================================


// Assign to variables ===========================================

// strip WIDTHxHEIGHT into an array -------------
// list sub gallery thumbs
$my_list_thumbnail_width_height_array 		= explode('x', str_replace(' ','',$my_list_thumbnail_width_height));
// sub sub gallery thumbs
$my_detail_thumb_width_height_array 		= explode('x', str_replace(' ','',$my_detail_thumb_width_height));
// sub sub gallery thumbs if image count in folder > thumb_count_min 
$my_detail_thumb_width_height_min_array 	= explode('x', str_replace(' ','',$my_detail_thumb_width_height_min));
// sub sub gallery width x height of the zoomed image
$my_detail_width_height_array 				= explode('x', str_replace(' ','',$my_detail_zoom_width_height));

// +kh: automatic article id
$my_article_id = 	0; 	// kh alias from the calling article where {GALLERYX:...} is stored
 if(!empty($GLOBALS['row']["article_id"])) { $my_article_id = $GLOBALS['row']["article_id"]; } 


// define the root ID of gallery = where to start recursive search
// by default root ID = 0 which is top level
 $gallery->gallery_rootid	= $my_gallery_rootid; // Gallery folder root (parent)

// define the sub_sub gallery id = default 0
// only this gallery 
 $gallery->gallery_sub_subid = $my_gallery_sub_subid; 

 $gallery->setAlias( 'aid='.$my_article_id );  // alias from the calling article where {GALLERYX:...} is stored


// string defines the sorting mode of the Gallery and Sub Galleries image folder:
// NAME-ASC, NAME-DESC, CREATE-ASC, CREATE-DESC
// get images sorted by name or create date
// $gallery->gallery_sort	= 'NAME-ASC';
$gallery->setGallerySort($my_gallery_sort);

/* not in use
$gallery->list_image_width		= 70;
$gallery->list_image_height		= 70;
$gallery->list_image_crop		= 0;
*/


// bbbbbbbbbbbbbbbbbbbb
$gallery->list_template				= '	<div class="gallery">
	{TITLE}
	{THUMBNAIL}
	{DESCRIPTION}
	<div class="clear_both"></div>
</div>';

$gallery->list_title_date					= $my_list_title_date;

// $gallery->list_title_prefix			= '<h3>[LINK]<strong>{DATE:d.m.Y}</strong> &#8211; ';

// if ($my_list_title_date == 1) { $gallery->list_title_prefix		= '<h3>[LINK]'; } //only title [1]
// else { $gallery->list_title_prefix	= '<h3>[LINK]<strong>'.$my_date_format.'</strong> &#8211; '; }



			switch ($my_list_title_date) {  // title and date in sub gallery (list)
			//	case 0: 
			// set in imagegalleryx.inc.php (we need a fallback if there is no thumbnail set)
				
				case 1: 
					$gallery->list_title_prefix		= '<h3>[LINK]';  //only title [1]
					break;
				case 2: 
					$gallery->list_title_prefix	= '<h3>[LINK]<strong>'.$my_date_format.'</strong> ';
					break;
				default: // [0 and 3]
					$gallery->list_title_prefix	= '<h3>[LINK]<strong>'.$my_date_format.'</strong> &#8211; ';
					break;
			}
			$gallery->list_title_suffix	= '[/LINK]</h3>';
			
$gallery->list_thumbnail_prefix		= '<div class="thumbnail">[LINK]';
$gallery->list_thumbnail_suffix		= '[/LINK]</div>';
// eeeeeeeeeeeeeeeeeeee

// automatic assign for the list thumbnail (see user assign)
if (isset($my_list_thumbnail_width_height_array[1])) {
	$gallery->list_thumbnail_width		= intval ($my_list_thumbnail_width_height_array[0]);
	$gallery->list_thumbnail_height		= intval ($my_list_thumbnail_width_height_array[1]);
} else { 
// bbbbbbbbbbbbbbbbbbbb
	$gallery->list_thumbnail_width		= 50;  // default fallback
	$gallery->list_thumbnail_width		= 50;  // default fallback
// eeeeeeeeeeeeeeeeeeee
	}

// define if an list sub gallery thumbnail should be shown
// 0 = show none, 1 show first, 2 show first and second ...(see user assign)
$gallery->list_thumbnail				= (boolean) $my_list_thumbnail;
$gallery->list_thumbnail_crop		= (boolean) $my_list_thumbnail_crop;

$gallery->list_thumbnail_caption	= (boolean) $my_list_thumbnail_caption;  // +kh

// bbbbbbbbbbbbbbbbbbbb
// -kh $gallery->list_descr_prefix			= '<div style="font-size: 11px"><strong>'.$my_date_format.'</strong> &#8211; ';
// +kh my_list_description_date [0|1]
$gallery->list_descr_prefix		= '<div style="font-size: 11px">';
if ( $my_list_description_date == 1 ) { 
$gallery->list_descr_prefix	.= '<strong>'.$my_date_format.'</strong> &#8211; '; 
}
$gallery->list_descr_suffix		= '</div>';
// eeeeeeeeeeeeeeeeeeee

// zoom and lightbox switch
$gallery->zoom 							= (boolean) $my_detail_zoom ;
$gallery->lightbox 					= (boolean) $my_detail_lightbox ; 

// build download template file name 
$gallery->item_download_template = trimhtml($my_item_download_template) . '.html';

// END of Assign to variables ====================================


// ------------ +kh: including the css file
$GLOBALS['block']['css']['gallery'] = 'specific/'. trim($my_gallery_css) . '.css'; 
// ------------

	$galleries = array();

// ------------ +kh: fetch the sub gallery id, if there is no one given 
 if ($my_gallery_subid > 0) {$GLOBALS['_getVar']['subgallery'] = $my_gallery_subid;} 
// ------------


	// List the galleries in selected sub gallery ===============
	if( isset($GLOBALS['_getVar']['subgallery']) ) {

		$GLOBALS['_getVar']['subgallery'] = intval($GLOBALS['_getVar']['subgallery']);
		
		$sql  = 'SELECT pf.*, pj.f_id AS f_root_id, pj.f_name AS f_root_name ';
		$sql .= 'FROM '.DB_PREPEND.'phpwcms_file pf ';
		$sql .= 'LEFT JOIN '.DB_PREPEND.'phpwcms_file pj ';
		$sql .= 'ON pf.f_pid=pj.f_id ';
		$sql .= 'WHERE pf.f_id='.$GLOBALS['_getVar']['subgallery'];

		$subgallery  = _dbQuery($sql);
		
		$gallery_breadcrumb = array();
		
		if(isset($subgallery[0])) {
		
			$subgallery				= $subgallery[0];
			$subgallery_get			= '';
			$subgallery_class		= 'root';
			$gallery_breadcrumb_url	= 'index.php'.returnGlobalGET_QueryString('htmlentities', array(), array('gallery', 'subgallery'), $gallery->alias);
		
			// check if parent directory exists
			if(!empty($subgallery['f_root_id'])) {
				$gallery_breadcrumb[]	= '<a href="'.$gallery_breadcrumb_url.'" class="root">'.html_specialchars($subgallery['f_root_name']).'</a>';
				$subgallery_get			= '&amp;subgallery='.$GLOBALS['_getVar']['subgallery'];
				$subgallery_class		= 'sub';
			}
			$gallery_breadcrumb[] = '<a href="'.$gallery_breadcrumb_url.$subgallery_get.'" class="'.$subgallery_class.'">'.html_specialchars($subgallery['f_name']).'</a>';	
		
		}
		

		// ========================================================
		// show gallery images 
		// ========================================================
		
		if ($my_gallery_sub_subid > 0) {$GLOBALS['_getVar']['gallery'] = $my_gallery_sub_subid;}
		
		if( isset($GLOBALS['_getVar']['gallery']) ) {

		// Define the images ==========================

			$gallery->download				= (boolean)  $my_download;
			$gallery->download_direct		= (boolean)  $my_download_direct;

		// string defines the sorting mode
		// ASC/DESC = get images sorted by date 
		// NAME-ASC/DESC = get images sorted by name  (+kh) 
		// RAND = get images by random)
			$gallery->image_sort			= trim($my_gallery_image_sort); 	// sorting gallery images
			$gallery->image_limit			= trim($my_gallery_image_limit); 	// integer the limit of how many images should be retrieved

			if (isset($my_detail_thumb_width_height_array[1])) {
				$gallery->thumb_width		= intval(trim($my_detail_thumb_width_height_array[0]));
				$gallery->thumb_height		= intval(trim($my_detail_thumb_width_height_array[1]));
			} else { 
				// bbbbbbbbbbbbbbbbbbbb
				$gallery->thumb_width		= 160;  // default
				$gallery->thumb_height		= 160;  // default
				}
				// eeeeeeeeeeeeeeeeeeee
			
			// -------- +kh
			// If more then "thumb_count_to_min" images in selected sub gallery placed, 
			// they will be reduced to "thumb_width_min" and "thumb_height_min"
			$gallery->thumb_count_to_min	= intval($my_detail_thumb_count_to_min);
			
			if (isset($my_thumb_width_height_min_array[1])) {
				$gallery->thumb_width_min	= intval(trim($my_detail_thumb_width_height_min_array[0]));
				$gallery->thumb_height_min	= intval(trim($my_detail_thumb_width_height_min_array[1]));
			} else { 
				// bbbbbbbbbbbbbbbbbbbb
				$gallery->thumb_width_min	= 100;  // default fallback
				$gallery->thumb_height_min	= 100;  // default fallback
				}
				// eeeeeeeeeeeeeeeeeeee
			// --------
			
			if (isset($my_detail_width_height_array[1])) {
				$gallery->width				= intval(trim($my_detail_width_height_array[0]));
				$gallery->height			= intval(trim($my_detail_width_height_array[1]));
			} else { 
				$gallery->width				= 600;  // default fallback
				$gallery->height			= 480;  // default fallback
				}
				

			$gallery->detail_descr_info		= (boolean) $my_detail_descr_info; // +kh: // +kh: Description from list in detail on/off
			
			// bbbbbbbbbbbbbbbbbbbb
			$gallery->detail_title_date			= $my_detail_title_date;
//			if ($my_detail_title_date == 1) { $gallery->detail_title_prefix		= '<h2>'; } //only title [1]
//			else { $gallery->detail_title_prefix		= '<h2><strong>'.$my_date_format.'</strong> &#8211; '; }

			$gallery->detail_title_suffix		= '</h2>';
			
			switch ($my_detail_title_date) {
				case 0: 
					$gallery->detail_title_prefix		= '';
					$gallery->detail_title_suffix		= '';
					break;
				case 1: 
					$gallery->detail_title_prefix		= '<h2>';
					break;
				case 2: 
					$gallery->detail_title_prefix		= '<h2><strong>'.$my_date_format.'</strong> ';
					break;
				default:
					$gallery->detail_title_prefix		= '<h2><strong>'.$my_date_format.'</strong> &#8211; ';
					break;
			}
			
			$gallery->detail_descr_prefix	= '<div style="font-size: 12px">';
			$gallery->detail_descr_suffix	= '</div>';
			
			$gallery->detail_gallery_back	= '<div class="backlink">[LINK]'.trimhtml($my_go_back_text).'[/LINK]</div>';
			// eeeeeeeeeeeeeeeeeeee
			
			$gallery->detail_thumbnail_crop			= (boolean) $my_detail_thumb_crop;
			$gallery->detail_thumbnail_caption		= (boolean) $my_detail_thumb_caption; 
			$gallery->detail_zoom_crop				= (boolean) $my_detail_zoom_crop;
			// bbbbbbbbbbbbbbbbbbbb
			$gallery->detail_thumbnail_prefix		= '<div class="thumbnail">';
			$gallery->detail_thumbnail_suffix		= '<hr />{DOWNLOAD}</div>';
			$gallery->detail_caption_prefix			= '<div class="caption">';
			$gallery->detail_caption_suffix			= '</div>';
			// ----------- +kh: copyright add
			$gallery->detail_copyr_prefix			= '<span style="font-size: 10px">';
			$gallery->detail_copyr_suffix			= '</span>';
			$gallery->detail_copyr_general_string	= trim($my_copyright_text);  // set general copyright text over all
			$gallery->detail_copyr_text_prefix		= '&copy; '; 
			// eeeeeeeeeeeeeeeeeeee
			// -----------
			
			// End of define the images ========================


			// sub sub gallery output
			$galleries[] = $gallery->showGallery( $GLOBALS['_getVar']['gallery'] );
			
			// show title of selected gallery
			if(isset($gallery->gallery['f_name'])) { 
				$gallery_breadcrumb[] = '<span class="active">'.html_specialchars($gallery->gallery['f_name']).'</span>';	
			}

		} else {  // list of subgalleries 
		
			$galleries[] = $gallery->listGalleries( $GLOBALS['_getVar']['subgallery'] );
			
		}
		
		// render current gallery path
//		if(count($gallery_breadcrumb)) { // -kh
		if(count($gallery_breadcrumb) && $my_gallery_subid == 0) { // +kh add my_gallery_subid
			array_unshift($galleries, '<div class="gallery_breadcrumb">' . LF . '	' . implode(' / ', $gallery_breadcrumb) . LF . '</div>');
		}

		$gallery = implode(LF, $galleries);


	// list sub galleries in root (parent folder (first level))
	} else {
	
		$gallery_root = $gallery->getGalleryTree();
		
		$g = 0;

		foreach($gallery_root as $row) {
	
			$subgalleries   = $gallery->getGallerySub($row['f_id']);
			
			$subgallery		= '';
			if(is_array($subgalleries) && count($subgalleries)) {
				
				$subgallery  = '		<ul class="sub">' . LF;
				
				foreach($subgalleries as $sub) {
					
					$subgallery .= '			<li class="sub">' . LF;
					$subgallery .= '				<h3><a href="'.$gallery->url.'&amp;subgallery='.$sub['f_id'].'">';
					$subgallery .=					html_specialchars($sub['f_name']).'</a></h3>' . LF;
					if($row['f_longinfo'] != '') {
						$subgallery .= '		' . plaintext_htmlencode($sub['f_longinfo']) . LF;
					}
					$subgallery .= '			</li>' . LF;
				}
				
				$subgallery .= '		</ul>' . LF;
			}
			
			$galleries[$g]  = '	<li class="root">' . LF;
			$galleries[$g] .= '		<h2>';
			
			if($subgallery != '') {
				$galleries[$g] .= html_specialchars($row['f_name']);
			} else {
				$galleries[$g] .= '<a href="'.$gallery->url.'&amp;subgallery='.$row['f_id'].'">' . html_specialchars($row['f_name']) . '</a>';
			}
			
			$galleries[$g] .= '</h2>' . LF;
			if($row['f_longinfo'] != '') {
				$galleries[$g] .= '		' . plaintext_htmlencode($row['f_longinfo']) . LF;
			}
			$galleries[$g] .= $subgallery;	
			$galleries[$g] .= '	</li>';
			$g++;

		}
		
				
		$gallery = count($galleries) ? '<ul class="gallery">' . LF . implode(LF, $galleries) . LF . '</ul>' : '';
	
	}
// return '<hr /><h1>Gallery</h1>'.LF.$gallery.LF.'<hr />';
return $gallery;
}
// END of GALLERY ===================================


	$content["all"] = preg_replace('/\{GALLERYX:(.*?)\}/e', 'my_parameter("$1");', $content["all"]);

}

?>